#include "galpropy.hpp"

void bind_Distribution(py::module_ &m)
{
    py::class_<Dimensions>(m, "Dimensions").def(py::init<>())
        .def("is1", &Dimensions::is1)
        .def("is2", &Dimensions::is2)
        .def("is3", &Dimensions::is3)
        .def("ndim", &Dimensions::ndim)
        .def("npos", &Dimensions::npos)
        .def_readwrite("nx", &Dimensions::nx)
        .def_readwrite("nE", &Dimensions::nE)
        .def_readwrite("nGamma", &Dimensions::nGamma)
        .def_readwrite("nSynch", &Dimensions::nSynch)
        .def_readwrite("nlon", &Dimensions::nlat)
        .def_readwrite("nRbin", &Dimensions::nRbin)
        .def_readwrite("dx", &Dimensions::dx)
        .def_readwrite("dy", &Dimensions::dy)
        .def_readwrite("dr", &Dimensions::dr)
        .def_readwrite("dz", &Dimensions::dz)
        .def_readwrite("Ekin_factor", &Dimensions::Ekin_factor)
        .def_readwrite("EGamma_factor", &Dimensions::EGamma_factor)
        .def_readwrite("ESynch_factor", &Dimensions::ESynch_factor)
        .def_readwrite("dlon", &Dimensions::dlon)
        .def_readwrite("dlat", &Dimensions::dlat)
        .def_readwrite("x_min", &Dimensions::x_min)
        .def_readwrite("y_min", &Dimensions::y_min)
        .def_readwrite("r_min", &Dimensions::r_min)
        .def_readwrite("z_min", &Dimensions::z_min)
        .def_readwrite("Ekin_min", &Dimensions::Ekin_min)
        .def_readwrite("EGamma_min", &Dimensions::EGamma_min)
        .def_readwrite("ESynch_min", &Dimensions::ESynch_min)
        .def_readwrite("lon_min", &Dimensions::lon_min)
        .def_readwrite("lat_min", &Dimensions::lat_min);

    py::bind_vector<std::vector<Distribution>>(m, "VecDistribution");
    py::implicitly_convertible<py::list, std::vector<Distribution>>();
    py::implicitly_convertible<py::tuple, std::vector<Distribution>>();
    py::class_<Distribution>(m, "Distribution")
        .def(py::init<>())
        .def("init", py::overload_cast<size_t, size_t, size_t, size_t>
             (&Distribution::init))
        .def("init", py::overload_cast<size_t, size_t, size_t>
             (&Distribution::init))
        .def("init", py::overload_cast<const Dimensions&, size_t>
             (&Distribution::init), "dims"_a, "np"_a=0)
        .def("max", &Distribution::max)
        .def("slice", py::overload_cast<size_t, size_t, size_t>(
             &Distribution::slice))
        .def("slice", py::overload_cast<size_t, size_t, size_t>(
             &Distribution::slice, py::const_))
        .def("slice", py::overload_cast<size_t>(&Distribution::slice))
        .def("slice", py::overload_cast<size_t>(&Distribution::slice, py::const_))
        // TODO .at()
        .def("local_spec", &Distribution::local_spec)
        .def("local_spec_1d", &Distribution::local_spec_1d)
        .def("local_spec_2d", &Distribution::local_spec_2d)
        .def("local_spec_3d", &Distribution::local_spec_3d)
        .def("delete_array", &Distribution::delete_array)
        .def_readwrite("dist", &Distribution::dist)
        .def_readwrite("n_spatial_dimensions", &Distribution::n_spatial_dimensions)
        .def_readwrite("n_pgrid", &Distribution::n_pgrid)
        .def_readwrite("n_rgrid", &Distribution::n_rgrid)
        .def_readwrite("n_xgrid", &Distribution::n_xgrid)
        .def_readwrite("n_ygrid", &Distribution::n_ygrid)
        .def_readwrite("n_zgrid", &Distribution::n_zgrid);
}
