#include <galprop/Galdef.h>
#include "galpropy.hpp"

void bind_Galdef(py::module_ &m)
{
    py::class_<Galdef>(m, "Galdef").def(py::init<>())
        .def_readwrite("version", &Galdef::version)
        .def_readwrite("run_no", &Galdef::run_no)
        .def_readwrite("galdef_ID", &Galdef::galdef_ID)
        .def_readwrite("n_spatial_dimensions", &Galdef::n_spatial_dimensions)
        .def_readwrite("z_min", &Galdef::z_min)
        .def_readwrite("z_max", &Galdef::z_max)
        .def_readwrite("dz", &Galdef::dz)
        .def_readwrite("r_min", &Galdef::r_min)
        .def_readwrite("r_max", &Galdef::r_max)
        .def_readwrite("dr", &Galdef::dr)
        .def_readwrite("x_min", &Galdef::x_min)
        .def_readwrite("x_max", &Galdef::x_max)
        .def_readwrite("dx", &Galdef::dx)
        .def_readwrite("y_min", &Galdef::y_min)
        .def_readwrite("y_max", &Galdef::y_max)
        .def_readwrite("dy", &Galdef::dy)
        .def_readwrite("Ekin_min", &Galdef::Ekin_min)
        .def_readwrite("Ekin_max", &Galdef::Ekin_max)
        .def_readwrite("Ekin_factor", &Galdef::Ekin_factor)
        .def_readwrite("E_gamma_min", &Galdef::E_gamma_min)
        .def_readwrite("E_gamma_max", &Galdef::E_gamma_max)
        .def_readwrite("E_gamma_factor", &Galdef::E_gamma_factor)
        .def_readwrite("nu_synch_min", &Galdef::nu_synch_min)
        .def_readwrite("nu_synch_max", &Galdef::nu_synch_max)
        .def_readwrite("nu_synch_factor", &Galdef::nu_synch_factor)
        .def_readwrite("long_min", &Galdef::long_min)
        .def_readwrite("long_max", &Galdef::long_max)
        .def_readwrite("d_long", &Galdef::d_long)
        .def_readwrite("lat_min", &Galdef::lat_min)
        .def_readwrite("lat_max", &Galdef::lat_max)
        .def_readwrite("d_lat", &Galdef::d_lat)
        .def_readwrite("integration_mode", &Galdef::integration_mode)
        .def_readwrite("healpix_order", &Galdef::healpix_order)
        .def_readwrite("lat_substep_number", &Galdef::lat_substep_number)
        .def_readwrite("LoS_step", &Galdef::LoS_step)
        .def_readwrite("LoS_substep_number", &Galdef::LoS_substep_number)
        .def_readwrite("start_timestep", &Galdef::start_timestep)
        .def_readwrite("end_timestep", &Galdef::end_timestep)
        .def_readwrite("timestep_factor", &Galdef::timestep_factor)
        .def_readwrite("timestep_repeat", &Galdef::timestep_repeat)
        .def_readwrite("timestep_print", &Galdef::timestep_print)
        .def_readwrite("timestep_diagnostics", &Galdef::timestep_diagnostics)
        .def_readwrite("control_diagnostics", &Galdef::control_diagnostics)
        .def_readwrite("prop_r", &Galdef::prop_r)
        .def_readwrite("prop_x", &Galdef::prop_x)
        .def_readwrite("prop_y", &Galdef::prop_y)
        .def_readwrite("prop_z", &Galdef::prop_z)
        .def_readwrite("prop_p", &Galdef::prop_p)
        .def_readwrite("use_symmetry", &Galdef::use_symmetry)
        .def_readwrite("D0_xx", &Galdef::D0_xx)
        .def_readwrite("D_rigid_br", &Galdef::D_rigid_br)
        .def_readwrite("D_g_1", &Galdef::D_g_1)
        .def_readwrite("D_g_2", &Galdef::D_g_2)
        .def_readwrite("D_eta", &Galdef::D_eta)
        .def_readwrite("diff_reacc", &Galdef::diff_reacc)
        .def_readwrite("v_Alfven", &Galdef::v_Alfven)
        .def_readwrite("damping_p0", &Galdef::damping_p0)
        .def_readwrite("damping_max_path_L", &Galdef::damping_max_path_L)
        .def_readwrite("damping_const_G", &Galdef::damping_const_G)
        .def_readwrite("convection", &Galdef::convection)
        .def_readwrite("v0_conv", &Galdef::v0_conv)
        .def_readwrite("dvdz_conv", &Galdef::dvdz_conv)
        .def_readwrite("He_H_ratio", &Galdef::He_H_ratio)
        .def_readwrite("n_X_CO", &Galdef::n_X_CO)
        .def_readwrite("n_X_CO_values", &Galdef::n_X_CO_values)
        .def_readwrite("X_CO", &Galdef::X_CO)
        .def_readwrite("X_CO_radius", &Galdef::X_CO_radius)
        .def_readwrite("X_CO_values", &Galdef::X_CO_values)
        // .def_readwrite("X_CO_parameters", &Galdef::X_CO_parameters)
        .def_readwrite("propagation_X_CO", &Galdef::propagation_X_CO)
        .def_readwrite("nHI_model", &Galdef::nHI_model)
        .def_readwrite("nH2_model", &Galdef::nH2_model)
        .def_readwrite("nHII_model", &Galdef::nHII_model)
        .def_readwrite("nHI_factor", &Galdef::nHI_factor)
        .def_readwrite("nHII_factor", &Galdef::nHII_factor)
        .def_readwrite("nH2_factor", &Galdef::nH2_factor)
        .def_readwrite("COR_filename", &Galdef::COR_filename)
        .def_readwrite("HIR_filename", &Galdef::HIR_filename)
        .def_readwrite("fragmentation", &Galdef::fragmentation)
        .def_readwrite("momentum_losses", &Galdef::momentum_losses)
        .def_readwrite("radioactive_decay", &Galdef::radioactive_decay)
        .def_readwrite("K_capture)", &Galdef::K_capture)
        .def_readwrite("ionization_rate)", &Galdef::ionization_rate)
        .def_readwrite("source_specification)", &Galdef::source_specification)
        .def_readwrite("source_normalization)", &Galdef::source_normalization)
        .def_readwrite("electron_source_normalization)", &Galdef::electron_source_normalization)
        .def_readwrite("use_Z", &Galdef::use_Z)
        .def_readwrite("max_Z", &Galdef::max_Z)
        .def_readwrite("isotopic_abundance", &Galdef::isotopic_abundance)
        .def_readwrite("total_cross_section", &Galdef::total_cross_section)
        .def_readwrite("cross_section_option", &Galdef::cross_section_option)
        .def_readwrite("t_half_limit", &Galdef::t_half_limit)
        .def_readwrite("primary_electrons", &Galdef::primary_electrons)
        .def_readwrite("secondary_electrons", &Galdef::secondary_electrons)
        .def_readwrite("secondary_positrons", &Galdef::secondary_positrons)
        .def_readwrite("knock_on_electrons", &Galdef::knock_on_electrons)
        .def_readwrite("secondary_antiDeuterium", &Galdef::secondary_antiDeuterium)
        .def_readwrite("secondary_antiHelium", &Galdef::secondary_antiHelium)
        .def_readwrite("secondary_protons", &Galdef::secondary_protons)
        .def_readwrite("secondary_antiprotons", &Galdef::secondary_antiprotons)
        .def_readwrite("tertiary_antiprotons", &Galdef::tertiary_antiprotons)
        .def_readwrite("primary_DM_electrons", &Galdef::primary_DM_electrons)
        .def_readwrite("primary_DM_positrons", &Galdef::primary_DM_positrons)
        .def_readwrite("primary_DM_antiprotons", &Galdef::primary_DM_antiprotons)
        .def_readwrite("primary_DM_antiHelium", &Galdef::primary_DM_antiHelium)
        .def_readwrite("primary_DM_antiDeuterium", &Galdef::primary_DM_antiDeuterium)
        .def_readwrite("tertiary_DM_antiprotons", &Galdef::tertiary_DM_antiprotons)
        .def_readwrite("source_model", &Galdef::source_model)
        .def_readwrite("source_model_electron", &Galdef::source_model_electron)
        .def_readwrite("source_parameters", &Galdef::source_parameters)
        .def_readwrite("source_parameters_electron", &Galdef::source_parameters_electron)
        .def_readwrite("source_radius", &Galdef::source_radius)
        .def_readwrite("source_values", &Galdef::source_values)
        .def_readwrite("n_source_values", &Galdef::n_source_values)
        .def_readwrite("gamma_rays", &Galdef::gamma_rays)
        .def_readwrite("pi0_decay", &Galdef::pi0_decay)
        .def_readwrite("IC_isotropic", &Galdef::IC_isotropic)
        .def_readwrite("IC_anisotropic", &Galdef::IC_anisotropic)
        .def_readwrite("bremss", &Galdef::bremss)
        .def_readwrite("synchrotron", &Galdef::synchrotron)
        .def_readwrite("skymap_format", &Galdef::skymap_format)
        .def_readwrite("B_field_model", &Galdef::B_field_model)
        .def_readwrite("B_field_name", &Galdef::B_field_name)
        .def_readwrite("n_B_field_parameters", &Galdef::n_B_field_parameters)
        .def_readwrite("B_field_parameters", &Galdef::B_field_parameters)
        .def_readwrite("ISRF_file", &Galdef::ISRF_file)
        .def_readwrite("ISRF_filetype", &Galdef::ISRF_filetype)
        .def_readwrite("ISRF_healpixOrder", &Galdef::ISRF_healpixOrder)
        // .def_readwrite("ISRF_factors", &Galdef::ISRF_factors)
        .def_readwrite("proton_norm_Ekin", &Galdef::proton_norm_Ekin, "[MeV]")
        .def_readwrite("proton_norm_flux", &Galdef::proton_norm_flux)
        .def_readwrite("electron_norm_Ekin", &Galdef::electron_norm_Ekin, "[MeV]")
        .def_readwrite("electron_norm_flux", &Galdef::electron_norm_flux)
        .def_readwrite("verbose", &Galdef::verbose)
        .def_readwrite("nuc_rigid_br", &Galdef::nuc_rigid_br)
        .def_readwrite("nuc_g_1", &Galdef::nuc_g_1)
        .def_readwrite("nuc_g_2", &Galdef::nuc_g_2)
        .def_readwrite("electron_g_0", &Galdef::electron_g_0)
        .def_readwrite("electron_g_1", &Galdef::electron_g_1)
        .def_readwrite("electron_g_2", &Galdef::electron_g_2)
        .def_readwrite("electron_rigid_cutoff", &Galdef::electron_rigid_cutoff)
        .def_readwrite("electron_rigid_br0", &Galdef::electron_rigid_br0)
        .def_readwrite("electron_rigid_br", &Galdef::electron_rigid_br)
        .def_readwrite("electron_rigid_br2", &Galdef::electron_rigid_br2);
}
