#include "galpropy.hpp"

void bind_Galprop(py::module_ &m)
{
    py::class_<Galprop, std::unique_ptr<Galprop, py::nodelete>>(m, "Galprop")
        .def(py::init<>())
        .def("create_gcr", &Galprop::create_gcr)
        .def("create_galaxy", &Galprop::create_galaxy)
        // .def("cr_luminosity", &Galprop::cr_luminosity)
        .def("propagate_particles", &Galprop::propagate_particles)
        .def("D_pp", &Galprop::D_pp)
        .def("D_xx", &Galprop::D_xx)
        .def("nuclei_normalize", &Galprop::nuclei_normalize)
        .def("electron_normalize", &Galprop::electrons_normalize)
        .def("run_DM", &Galprop::run_DM)
        .def("propel", &Galprop::propel)
        .def("set_dpp_limit", &Galprop::set_dpp_limit)
        .def("load_config", &Galprop::load_config)
        .def("run", py::overload_cast<>(&Galprop::run), "run without arg")
        .def("run", py::overload_cast<const std::string &>(&Galprop::run),
             "run with name")
        .def("GetEkin", &Galprop::GetEkin)
        .def("GetFlux", &Galprop::GetFlux, "Get the flux by ParticleNumber",
             "ZA"_a, "ekin_toa"_a=std::valarray<double>{},
             "mod"_a=NoModulation())
        .def("GetFluxByName", &Galprop::GetFluxByName, "Get the flux by name",
             "name"_a, "ekin_toa"_a=std::valarray<double>{},
             "mod"_a=NoModulation())
        .def_readwrite("n_species", &Galprop::n_species)
        .def_readwrite("galdef", &Galprop::galdef)
        .def_readwrite("cfg", &Galprop::cfg)
        .def_readwrite("particle_lib", &Galprop::particle_lib)
        .def_readwrite("gcr", &Galprop::gcr)
        .def_readwrite("galaxy", &Galprop::galaxy)
        .def_readwrite("energy_losses", &Galprop::energy_losses)
        .def_readwrite("propel_operators", &Galprop::propel_operators)
        .def_readwrite("energy_loss_fallback", &Galprop::energy_loss_fallback);
        // .def_readwrite("propel_operator_fallback",
        //                &Galprop::propel_operator_fallback);
}
