#include <galprop/SecondaryParticle.h>
#include "galpropy.hpp"

void bind_SecondaryParticle(py::module_ &m) {
    py::class_<SecondaryProton, Particle, std::shared_ptr<SecondaryProton>>(
        m, "SecondaryProton")
        .def(py::init<std::shared_ptr<const ParticleInfo>,
                      std::shared_ptr<const Galaxy>,
                      const std::string &>())
        .def("cs_PP", &SecondaryProton::cs_PP)
        .def("cs_PHe", &SecondaryProton::cs_PHe);

    py::class_<SecondaryAntiproton, Particle,
               std::shared_ptr<SecondaryAntiproton>>(m, "SecondaryAntiproton")
        .def(py::init<std::shared_ptr<const ParticleInfo>,
                      std::shared_ptr<const Galaxy>,
                      const std::string &>())
        .def("cross_section", &SecondaryAntiproton::cross_section);

    py::class_<TertiaryAntiproton, Particle,
               std::shared_ptr<TertiaryAntiproton>>(m, "TertiaryAntiproton")
        .def(py::init<std::shared_ptr<const ParticleInfo>,
                      std::shared_ptr<const Galaxy>,
                      const std::string &>())
        .def("cross_section", &TertiaryAntiproton::cross_section);

    py::class_<SecondaryPositron, SecondaryAntiproton,
               std::shared_ptr<SecondaryPositron>>(m, "SecondaryPositron")
        .def(py::init<std::shared_ptr<const ParticleInfo>,
                      std::shared_ptr<const Galaxy>,
                      const std::string &>())
        .def("cross_section", &SecondaryPositron::cross_section);

    py::class_<SecondaryAntinucleus, Particle,
               std::shared_ptr<SecondaryAntinucleus>>(m, "SecondaryAntinucleus")
        .def(py::init<std::shared_ptr<const ParticleInfo>,
                      std::shared_ptr<const Galaxy>,
                      const std::string &>());
}
