#include "galpropy.hpp"

void bind_Structures(py::module_ &m)
{
    py::class_<ParticleNumber>(m, "ParticleNumber")
        .def(py::init<int, int>(), "z"_a, "a"_a=ParticleNumber::AnyA)
        .def(py::init([](const py::tuple& args) {
                std::size_t arg_len = py::len(args);
                if (arg_len < 1 || arg_len > 2) {
                    throw py::value_error("tuple length incorrect");
                }
                int Z = args[0].cast<int>();
                if (arg_len == 1) { return ParticleNumber(Z); }
                return ParticleNumber(Z, args[1].cast<int>());
            }))
        .def_readwrite("Z", &ParticleNumber::Z)
        .def_readwrite("A", &ParticleNumber::A)
        .def_readonly_static("AnyA", &ParticleNumber::AnyA)
        .def(py::self == py::self)
        .def(py::self != py::self)
        .def(py::self < py::self);
    py::implicitly_convertible<py::tuple, ParticleNumber>();
}
